Xerces-J API: Class HTMLSerializer

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xml.serialize
Class HTMLSerializer

    java.lang.Object
      |
      +--org.apache.xml.serialize.BaseMarkupSerializer
            |
            +--org.apache.xml.serialize.HTMLSerializer

Direct Known Subclasses:
  XHTMLSerializer

public class HTMLSerializer
extends BaseMarkupSerializer

Implements an HTML/XHTML serializer supporting both DOM and SAX pretty serializing. HTML/XHTML mode is determined in the constructor. For usage instructions see `Serializer`.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. DOM serializing is done by calling `BaseMarkupSerializer.serialize(org.w3c.dom.Element)` and SAX serializing is done by firing SAX events and using the serializer as a document handler.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

XHTML is slightly different than HTML:

- Element/attribute names are lower case and case matters
- Attributes must specify value, even if empty string
- Empty elements must have '/' in empty tag
- Contents of SCRIPT and STYLE elements serialized as CDATA

Version:
  $Revision: 1.15.2.1 $ $Date: 2001/11/07 19:00:34 $
Author:
  Assaf Arkin
See Also:
  `Serializer`

Field Summary
`static java.lang.String` | `XHTMLNamespace`

Fields inherited from class org.apache.xml.serialize.BaseMarkupSerializer
`_docTypePublicId, _docTypeSystemId, _format, _indenting, _prefixes, _printer, _started`

Constructor Summary
`` | `HTMLSerializer()` Constructs a new serializer.
`protected` | `HTMLSerializer(boolean xhtml, OutputFormat format)` Constructs a new HTML/XHTML serializer depending on the value of `xhtml`.
`` | `HTMLSerializer(OutputFormat format)` Constructs a new serializer.
`` | `HTMLSerializer(java.io.OutputStream output, OutputFormat format)` Constructs a new serializer that writes to the specified output stream using the specified output format.
`` | `HTMLSerializer(java.io.Writer writer, OutputFormat format)` Constructs a new serializer that writes to the specified writer using the specified output format.

Method Summary
`void` | `characters(char[] chars, int start, int length)` Receive notification of character data.
`protected void` | `characters(java.lang.String text)` Called to print the text contents in the prevailing element format.
`void` | `endElement(java.lang.String tagName)` Receive notification of the end of an element.
`void` | `endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)` Receive notification of the end of an element.
`void` | `endElementIO(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)`
`protected java.lang.String` | `escapeURI(java.lang.String uri)`
`protected java.lang.String` | `getEntityRef(int ch)` Returns the suitable entity reference for this character value, or null if no such entity exists.
`protected void` | `serializeElement(Element elem)` Called to serialize a DOM element.
`void` | `setOutputFormat(OutputFormat format)` Specifies an output format for this serializer.
`protected void` | `startDocument(java.lang.String rootTagName)` Called to serialize the document's DOCTYPE by the root element.
`void` | `startElement(java.lang.String tagName, AttributeList attrs)` Receive notification of the beginning of an element.
`void` | `startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName, Attributes attrs)` Receive notification of the beginning of an element.

Methods inherited from class org.apache.xml.serialize.BaseMarkupSerializer
`asContentHandler, asDocumentHandler, asDOMSerializer, attributeDecl, comment, comment, content, elementDecl, endCDATA, endDocument, endDTD, endEntity, endNonEscaping, endPrefixMapping, endPreserving, enterElementState, externalEntityDecl, getElementState, getPrefix, ignorableWhitespace, internalEntityDecl, isDocumentState, leaveElementState, notationDecl, prepare, printDoctypeURL, printEscaped, printEscaped, printText, printText, processingInstruction, processingInstructionIO, reset, serialize, serialize, serialize, serializeNode, serializePreRoot, setDocumentLocator, setOutputByteStream, setOutputCharStream, skippedEntity, startCDATA, startDocument, startDTD, startEntity, startNonEscaping, startPrefixMapping, startPreserving, unparsedEntityDecl`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### XHTMLNamespace

    public static java.lang.String XHTMLNamespace

Constructor Detail

### HTMLSerializer

    protected HTMLSerializer(boolean xhtml,
                             OutputFormat format)

  Constructs a new HTML/XHTML serializer depending on the value of `xhtml`. The serializer cannot be used without calling `#init` first.
  Parameters:
    `xhtml` - True if XHTML serializing

### HTMLSerializer

    public HTMLSerializer()

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### HTMLSerializer

    public HTMLSerializer(OutputFormat format)

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### HTMLSerializer

    public HTMLSerializer(java.io.Writer writer,
                          OutputFormat format)

  Constructs a new serializer that writes to the specified writer using the specified output format. If `format` is null, will use a default output format.
  Parameters:
    `writer` - The writer to use
    `format` - The output format to use, null for the default

### HTMLSerializer

    public HTMLSerializer(java.io.OutputStream output,
                          OutputFormat format)

  Constructs a new serializer that writes to the specified output stream using the specified output format. If `format` is null, will use a default output format.
  Parameters:
    `output` - The output stream to use
    `format` - The output format to use, null for the default

Method Detail

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Description copied from interface: Serializer
  Specifies an output format for this serializer. It the serializer has already been associated with an output format, it will switch to the new format. This method should not be called while the serializer is in the process of serializing a document.
  Overrides:
    setOutputFormat in class BaseMarkupSerializer
  Tags copied from interface: Serializer
  Parameters:
    `format` - The output format to use

### startElement

    public void startElement(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName,
                             Attributes attrs)
                      throws SAXException

  Description copied from interface: ContentHandler
  Receive notification of the beginning of an element.

  The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding `endElement` event for every startElement event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement event.

  This event allows up to three name components for each element:

  1. the Namespace URI;
  2. the local name; and
  3. the qualified (prefixed) name.

  Any or all of these may be provided, depending on the values of the http://xml.org/sax/features/namespaces and the http://xml.org/sax/features/namespace-prefixes properties:

  - the Namespace URI and local name are required when the namespaces property is true (the default), and are optional when the namespaces property is false (if one is specified, both must be);
  - the qualified name is required when the namespace-prefixes property is true, and is optional when the namespace-prefixes property is false (the default).

  Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted. The attribute list will contain attributes used for Namespace declarations (xmlns* attributes) only if the `http://xml.org/sax/features/namespace-prefixes` property is true (it is false by default, and support for a true value is optional).

  Tags copied from interface: ContentHandler
  Parameters:
    `uri` - The Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed.
    `localName` - The local name (without prefix), or the empty string if Namespace processing is not being performed.
    `qName` - The qualified name (with prefix), or the empty string if qualified names are not available.
    `atts` - The attributes attached to the element. If there are no attributes, it shall be an empty Attributes object.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`, `Attributes`

### endElement

    public void endElement(java.lang.String namespaceURI,
                           java.lang.String localName,
                           java.lang.String rawName)
                    throws SAXException

  Description copied from interface: ContentHandler
  Receive notification of the end of an element.

  The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding `startElement` event for every endElement event (even when the element is empty).

  For information on the names, see startElement.

  Tags copied from interface: ContentHandler
  Parameters:
    `uri` - The Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed.
    `localName` - The local name (without prefix), or the empty string if Namespace processing is not being performed.
    `qName` - The qualified XML 1.0 name (with prefix), or the empty string if qualified names are not available.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.

### endElementIO

    public void endElementIO(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName)
                      throws java.io.IOException

### characters

    public void characters(char[] chars,
                           int start,
                           int length)
                    throws SAXException

  Description copied from interface: ContentHandler
  Receive notification of character data.

  The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity so that the Locator provides useful information.

  The application must not attempt to read from the array outside of the specified range.

  Note that some parsers will report whitespace in element content using the `ignorableWhitespace` method rather than this one (validating parsers must do so).

  Overrides:
    characters in class BaseMarkupSerializer
  Tags copied from interface: ContentHandler
  Parameters:
    `ch` - The characters from the XML document.
    `start` - The start position in the array.
    `length` - The number of characters to read from the array.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.ignorableWhitespace(char[], int, int)`, `Locator`

### startElement

    public void startElement(java.lang.String tagName,
                             AttributeList attrs)
                      throws SAXException

  Description copied from interface: DocumentHandler
  Receive notification of the beginning of an element.

  The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding endElement() event for every startElement() event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement() event.

  If the element name has a namespace prefix, the prefix will still be attached. Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted.

  Tags copied from interface: DocumentHandler
  Parameters:
    `name` - The element type name.
    `atts` - The attributes attached to the element, if any.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
  See Also:
    `DocumentHandler.endElement(java.lang.String)`, `AttributeList`

### endElement

    public void endElement(java.lang.String tagName)
                    throws SAXException

  Description copied from interface: DocumentHandler
  Receive notification of the end of an element.

  The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding startElement() event for every endElement() event (even when the element is empty).

  If the element name has a namespace prefix, the prefix will still be attached to the name.

  Tags copied from interface: DocumentHandler
  Parameters:
    `name` - The element type name
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.

### startDocument

    protected void startDocument(java.lang.String rootTagName)
                          throws java.io.IOException

  Called to serialize the document's DOCTYPE by the root element. The document type declaration must name the root element, but the root element is only known when that element is serialized, and not at the start of the document.

  This method will check if it has not been called before (`BaseMarkupSerializer._started`), will serialize the document type declaration, and will serialize all pre-root comments and PIs that were accumulated in the document (see `BaseMarkupSerializer.serializePreRoot()`). Pre-root will be serialized even if this is not the first root element of the document.

### serializeElement

    protected void serializeElement(Element elem)
                             throws java.io.IOException

  Called to serialize a DOM element. Equivalent to calling `startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`, `endElement(java.lang.String, java.lang.String, java.lang.String)` and serializing everything inbetween, but better optimized.
  Overrides:
    serializeElement in class BaseMarkupSerializer
  Tags copied from class: BaseMarkupSerializer
  Parameters:
    `elem` - The element to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### characters

    protected void characters(java.lang.String text)
                       throws java.io.IOException

  Description copied from class: BaseMarkupSerializer
  Called to print the text contents in the prevailing element format. Since this method is capable of printing text as CDATA, it is used for that purpose as well. White space handling is determined by the current element state. In addition, the output format can dictate whether the text is printed as CDATA or unescaped.
  Overrides:
    characters in class BaseMarkupSerializer
  Tags copied from class: BaseMarkupSerializer
  Parameters:
    `text` - The text to print
    `unescaped` - True is should print unescaped
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### getEntityRef

    protected java.lang.String getEntityRef(int ch)

  Description copied from class: BaseMarkupSerializer
  Returns the suitable entity reference for this character value, or null if no such entity exists. Calling this method with `'&'` will return `"&amp;"`.
  Overrides:
    getEntityRef in class BaseMarkupSerializer
  Tags copied from class: BaseMarkupSerializer
  Parameters:
    `ch` - Character value
  Returns:
    Character entity name, or null

### escapeURI

    protected java.lang.String escapeURI(java.lang.String uri)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2001 Apache XML Project. All Rights Reserved.